//
//  TEAppDelegate.swift
//  TextEditDoc
//
//  Created by narita on 2017/12/25.
//  Copyright © 2017年 narita. All rights reserved.
//

import Cocoa

@NSApplicationMain
class TEAppDelegate: NSObject, NSApplicationDelegate
{
    // MARK: - class methods
    
    // MARK: - init methods
    
    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods
    
    // MARK: - action methods
    
    func newDocumentOfType(ofType typeName: String)
    {
        do
        {
            let theDocument: NSDocument = try NSDocumentController.shared.makeUntitledDocument(ofType: typeName as String)
            
            NSDocumentController.shared.addDocument(theDocument)
            theDocument.makeWindowControllers()
            theDocument.showWindows()
        }
        catch
        {
            NSException(
                name: NSExceptionName.invalidArgumentException,
                reason: "\(typeName) is not a recognized document type.").raise()
        }
    }
    
    @IBAction func newPlaneTextDocument(_ sender: NSObject)
    {
        self.newDocumentOfType(ofType: kUTTypePlainText as String)
    }
    
    @IBAction func newRTFDocument(_ sender: NSObject)
    {
        self.newDocumentOfType(ofType: kUTTypeRTF as String)
    }
    
    @IBAction func newRTFDTextDocument(_ sender: NSObject)
    {
        self.newDocumentOfType(ofType: kUTTypeRTFD as String)
    }
    
    @IBAction func newHTMLDocument(_ sender: NSObject)
    {
        self.newDocumentOfType(ofType: kUTTypeHTML as String)
    }
    
    @IBAction func newWebArchiveDocument(_ sender: NSObject)
    {
        self.newDocumentOfType(ofType: kUTTypeWebArchive as String)
    }
    
    @IBAction func newDocumentFormTemplate(_ sender: NSObject)
    {
        // シングルトンのモードレスダイアログを作り
        // 静的なボタンが複数あり、ボタンを叩くと上記のNSDocumentController.makeDocument(for urlOrNil: URL?, withContentsOf contentsURL: URL, ofType typeName: String)で、適当なテンプレートからファイルを作る。
        
        let theWindowController = TETemplateWindowController.gTemplateWindowControllerInstance
        
        theWindowController.showWindow(nil)
    }
    
    // new document form Template メニュー項目のenable/disable
    func canNewDocumentFormTemplate(_ sender: NSObject) -> Bool
    {
        let theWindowController = TETemplateWindowController.gTemplateWindowControllerInstance

        if theWindowController.isWindowLoaded != false
        {
            return true
        }
        
        return theWindowController.window?.isMainWindow == false
    }
    
    // MARK: - event handling methods
    
    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods

    func applicationDidFinishLaunching(_ aNotification: Notification)
    {
        // Insert code here to initialize your application
    }

    func applicationWillTerminate(_ aNotification: Notification)
    {
        // Insert code here to tear down your application
    }
    
    // MARK: - accessor methods (in pairs)
    
    // MARK: - Utility methods
    
    // 頭が回らないのでパス
//    func validateUserInterfaceItem(_ item: NSValidatedUserInterfaceItem) -> Bool
//    {
//
//
//    }

}
